<?php

/**

 * track_outgoing_link allows you to track clicks on outgoing links with Google Analytics (you have to have an account)
 * vous permet de suivre les clics sur les liens sortants de votre site avec Google Analytics (vous devez posseder un compte)

 *

 * @author e-dijon.fr 2008

 * @package plugin_track_outgoing_link

 * @license GNU/GPL

 *

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,

 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR

 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM,

 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING

 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE

 * SOFTWARE.

 */



/* doesn't allow direct access */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' ); 

/* register the plugin */

$mainframe->registerEvent('onPrepareContent','plugin_track_outgoing_link');



/**

 * Add to all external urls the javascript code

 *

 * @param object $row

 * @param unknown_type $params

 * @param unknown_type $page

 * @return bool

 */

function plugin_track_outgoing_link( &$row, &$params, $page=0 ){

$database = &JFactory::getDBO();

	/* Check if we have some links in the content */

	if ( JString::strpos($row->text, 'href="') === false ) {
		return true;
	}

	/* Get Plugin info */

 	$plugin =& JPluginHelper::getPlugin('content', 'track_outgoing_link');

 	$plugin_params = new JParameter($plugin->params);
	
	$published = $plugin_params->get('publ', '0');
	
	if(!$published){
	 return true;
	}

	/* parse urls */
	$regex = '/<a (.*?)href=[\"\'](.*?)\/\/(.*?)[\"\'](.*?)>(.*?)<\/a>/i';
	$row->text = preg_replace_callback($regex, 'plugin_parse_track_outgoing_link', $row->text);

	/* great job */
	return true;
}



/**
 * Returns the domain from the URI
 *
 * @param string $uri
 * @return string Domain from input URI
 */

function pluginGetDomainFromUri($uri){
	preg_match("/^(http:\/\/)?([^\/]+)/i", $uri, $matches);
	$host = $matches[2];
	preg_match("/[^\.\/]+\.[^\.\/]+$/", $host, $matches);
	return $matches[0];
}


/**
 * parse each external link
 * @param string $matches
 * @return string
 */

function plugin_parse_track_outgoing_link($matches){

	$local	=& JFactory::getURI();
	
	$plugin =& JPluginHelper::getPlugin('content', 'track_outgoing_link');
 	$plugin_params = new JParameter($plugin->params);
	$path = $plugin_params->get('path');
	if(!$path || $path==''){
		$path = "outgoing";
	}

	if(pluginGetDomainFromUri($matches[3]) != $local->getHost()){
		return '<a href="' . $matches[2] . '//' . $matches[3] . '"' . $matches[1] . $matches[4] . '  onClick="javascript:pageTracker._trackPageview(\'/'.$path.'/' . $matches[3] . '\');"' . $matches[1] . $matches[4] . ' >' . $matches[5] . '</a>';
	} else {
		return '<a href="' . $matches[2] . '//' . $matches[3] . '"' . $matches[1] . $matches[4] . '>' . $matches[5] . '</a>';
	}
}

?>